/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by cantools version 28.8.1 Wed Oct 24 07:40:30 2018.
 */

#ifndef __MOTOHAWK_H__
#define __MOTOHAWK_H__

#include <stdint.h>
#include <unistd.h>

#ifndef EINVAL
#    define EINVAL -22
#endif

/**
 * Signals in message ExampleMessage.
 *
 * @param enable
 *            Scale: 1
 *            Offset: 0
 *            Unit: -
 * @param average_radius
 *            Minimum: 0
 *            Maximum: 5
 *            Scale: 0.1
 *            Offset: 0
 *            Unit: m
 * @param temperature
 *            Minimum: 229.53
 *            Maximum: 270.47
 *            Scale: 0.01
 *            Offset: 250
 *            Unit: degK
 */
struct motohawk_example_message_t {
    uint8_t enable;
    uint8_t average_radius;
    int16_t temperature;
};

/**
 * Encode message ExampleMessage.
 *
 * @param[out] dst_p Buffer to encode the message into.
 * @param[in] src_p Data to encode.
 * @param[in] size Size of dst_p.
 *
 * @return Size of encoded data, or negative error code.
 */
ssize_t motohawk_example_message_encode(
    uint8_t *dst_p,
    struct motohawk_example_message_t *src_p,
    size_t size);

/**
 * Decode message ExampleMessage.
 *
 * @param[out] dst_p Object to decode the message into.
 * @param[in] src_p Message to decode.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int motohawk_example_message_decode(
    struct motohawk_example_message_t *dst_p,
    uint8_t *src_p,
    size_t size);

#endif
