/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by cantools version 28.8.1 Wed Oct 24 07:40:34 2018.
 */

#include <string.h>

#include "multiplex.h"

ssize_t multiplex_message_1_encode(
    uint8_t *dst_p,
    struct multiplex_message_1_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(&dst_p[0], 0, 8);

    dst_p[0] |= ((src_p->multiplexor << 2) & 0xfc);

    switch (src_p->multiplexor) {

    case 8:
        dst_p[2] |= ((src_p->bit_c << 3) & 0x08);
        dst_p[2] |= ((src_p->bit_g << 7) & 0x80);
        dst_p[2] |= ((src_p->bit_j << 2) & 0x04);
        dst_p[3] |= ((src_p->bit_l << 0) & 0x01);
        break;

    case 16:
        dst_p[2] |= ((src_p->bit_c << 3) & 0x08);
        dst_p[2] |= ((src_p->bit_g << 7) & 0x80);
        dst_p[2] |= ((src_p->bit_j << 2) & 0x04);
        dst_p[3] |= ((src_p->bit_l << 0) & 0x01);
        break;

    case 24:
        dst_p[2] |= ((src_p->bit_c << 3) & 0x08);
        dst_p[2] |= ((src_p->bit_g << 7) & 0x80);
        dst_p[2] |= ((src_p->bit_j << 2) & 0x04);
        dst_p[3] |= ((src_p->bit_a << 2) & 0x04);
        dst_p[3] |= ((src_p->bit_e << 5) & 0x20);
        dst_p[3] |= ((src_p->bit_k << 4) & 0x10);
        dst_p[3] |= ((src_p->bit_l << 0) & 0x01);
        dst_p[4] |= ((src_p->bit_b << 1) & 0x02);
        dst_p[4] |= ((src_p->bit_d << 0) & 0x01);
        dst_p[4] |= ((src_p->bit_f << 7) & 0x80);
        dst_p[4] |= ((src_p->bit_h << 6) & 0x40);
        break;

    default:
        break;
    }

    return (8);
}

int multiplex_message_1_decode(
    struct multiplex_message_1_t *dst_p,
    uint8_t *src_p,
    size_t size)
{
    if (size < 8) {
        return (-EINVAL);
    }

    memset(dst_p, 0, sizeof(*dst_p));

    dst_p->multiplexor |= ((uint8_t)(src_p[0] & 0xfc) >> 2);

    switch (dst_p->multiplexor) {

    case 8:
        dst_p->bit_c |= ((uint8_t)(src_p[2] & 0x08) >> 3);
        dst_p->bit_g |= ((uint8_t)(src_p[2] & 0x80) >> 7);
        dst_p->bit_j |= ((uint8_t)(src_p[2] & 0x04) >> 2);
        dst_p->bit_l |= ((uint8_t)(src_p[3] & 0x01) >> 0);
        break;

    case 16:
        dst_p->bit_c |= ((uint8_t)(src_p[2] & 0x08) >> 3);
        dst_p->bit_g |= ((uint8_t)(src_p[2] & 0x80) >> 7);
        dst_p->bit_j |= ((uint8_t)(src_p[2] & 0x04) >> 2);
        dst_p->bit_l |= ((uint8_t)(src_p[3] & 0x01) >> 0);
        break;

    case 24:
        dst_p->bit_c |= ((uint8_t)(src_p[2] & 0x08) >> 3);
        dst_p->bit_g |= ((uint8_t)(src_p[2] & 0x80) >> 7);
        dst_p->bit_j |= ((uint8_t)(src_p[2] & 0x04) >> 2);
        dst_p->bit_a |= ((uint8_t)(src_p[3] & 0x04) >> 2);
        dst_p->bit_e |= ((uint8_t)(src_p[3] & 0x20) >> 5);
        dst_p->bit_k |= ((uint8_t)(src_p[3] & 0x10) >> 4);
        dst_p->bit_l |= ((uint8_t)(src_p[3] & 0x01) >> 0);
        dst_p->bit_b |= ((uint8_t)(src_p[4] & 0x02) >> 1);
        dst_p->bit_d |= ((uint8_t)(src_p[4] & 0x01) >> 0);
        dst_p->bit_f |= ((uint8_t)(src_p[4] & 0x80) >> 7);
        dst_p->bit_h |= ((uint8_t)(src_p[4] & 0x40) >> 6);
        break;

    default:
        break;
    }

    return (0);
}
