/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2018 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by cantools version 28.8.1 Wed Oct 24 07:40:30 2018.
 */

#ifndef __MULTIPLEX_H__
#define __MULTIPLEX_H__

#include <stdint.h>
#include <unistd.h>

#ifndef EINVAL
#    define EINVAL -22
#endif

/**
 * Signals in message ExampleMessage.
 *
 * @param bit_k
 * @param bit_d
 * @param bit_b
 * @param bit_f
 * @param bit_h
 * @param bit_e
 * @param bit_a
 * @param bit_l
 * @param bit_g
 * @param bit_c
 * @param bit_j
 * @param multiplexor
 */
struct multiplex_message_1_t {
    uint8_t bit_k;
    uint8_t bit_d;
    uint8_t bit_b;
    uint8_t bit_f;
    uint8_t bit_h;
    uint8_t bit_e;
    uint8_t bit_a;
    uint8_t bit_l;
    uint8_t bit_g;
    uint8_t bit_c;
    uint8_t bit_j;
    uint8_t multiplexor;
};

/**
 * Encode message Message1.
 *
 * @param[out] dst_p Buffer to encode the message into.
 * @param[in] src_p Data to encode.
 * @param[in] size Size of dst_p.
 *
 * @return Size of encoded data, or negative error code.
 */
ssize_t multiplex_message_1_encode(
    uint8_t *dst_p,
    struct multiplex_message_1_t *src_p,
    size_t size);

/**
 * Decode message Message1.
 *
 * @param[out] dst_p Object to decode the message into.
 * @param[in] src_p Message to decode.
 * @param[in] size Size of src_p.
 *
 * @return zero(0) or negative error code.
 */
int multiplex_message_1_decode(
    struct multiplex_message_1_t *dst_p,
    uint8_t *src_p,
    size_t size);

#endif
